function Item(o) {
    o = o || {};
    this.ctx = o.context;
    this.x = o.x || 0;
    this.y = o.y || 0;
    this.vx = o.vx || 0;
    this.vy = o.vy || 0;
    this.width = o.width || 16;
    this.height = o.height || 16;

    //where the top left corner is relative to the x y coord
    this.left = -8;
    this.top = -this.height+8; //align from bottom

    //optional properties
    this.type = o.type || 0; //0 - brick, 1 - door, 2 - key, 3 - chest, 4 - sword, 5 - shield, 6 - boots, 7 - helm, 8 - armor, 9 - spikes, 10 - final door, 11 - bullets from ghoul
    this.unlocked = false;
    this.img = o.img || false;
};
Item.prototype.update = function(delta){
    delta = delta || 1;

    this.x += this.vx;
    this.y += this.vy;
};
Item.prototype.render = function(ctx){
    ctx = ctx || this.ctx || false;

    if (ctx) {
        ctx.save();
            ctx.translate(this.x, this.y);
            if (this.img) {
                ctx.drawImage(this.img, this.left, this.top, this.width, this.height);
            } else {
                ctx.fillStyle = "this.color";
                ctx.fillRect(this.left, this.top, this.width, this.height);
            }
        ctx.restore();
    } else {
        console.log('No context specified in the update for:');
        console.log(this);
    }
};



// function GameObject(o) {
//     o = o || {};
//     this.ctx = o.context || context;
//     this.x = o.x || 0;
//     this.y = o.y || 0;
//     this.vx = o.vx || 0;
//     this.vy = o.vy || 0;
//     this.width = o.width || 0;
//     this.height = o.height || 0;

//     //optional properties
//     this.color = o.color || 'rgba(0, 0, 0, 1)';
//     this.type = o.type || 0;
//     this.health = o.health || 0;
//     this.img = o.img || false;
// };
// GameObject.prototype.update = function(delta){
//     delta = delta || 1;

//     this.x += this.vx;
//     this.y += this.vy;
// };
// GameObject.prototype.render = function(ctx){
//     ctx = ctx || this.ctx || context || false;

//     if (ctx) {
//         ctx.save();
//             ctx.translate(this.x, this.y);
//             if (this.img) {
//                 ctx.drawImage(this.img, -this.width/2, -this.height/2, this.width, this.height);
//             } else {
//                 ctx.fillStyle = this.color;
//                 ctx.fillRect(-this.width/2, -this.height/2, this.width, this.height);
//             }
//         ctx.restore();
//     } else {
//         console.log('No context specified in the update for:');
//         console.log(this);
//     }
// };


