function Monster(o) {
    o = o || {};
    this.ctx = o.context;

    this.type = o.type || 0; //12 - ghoul, 11 - boss

    this.x = o.x || 0;
    this.y = o.y || 0;
    this.vx = o.vx || 0;
    this.vy = o.vy || 0;

    if (this.type === 11) {
        this.width = o.width || 48;
        this.height = o.height || 64;
    } else {
        this.width = o.width || 32;
        this.height = o.height || 48;
    }

    //where the top left corner is relative to the x y coord
    this.left = -8;
    this.top = -this.height+8; //align from bottom

    this.spriteY = 0;
    this.animate = Math.floor(700 * Math.random());

    this.direction = 1; //facing

    //this.shootTimer = 1000 + Math.round(Math.random()*1000);
    this.shootTimer = o.shootTimer || 2000;
    this.bulletSpeed = o.bulletSpeed || 1;
    this.shoot = Math.random() * 500;
    this.bullets = [];

    //optional properties
    this.img = o.img || false;
};
Monster.prototype.update = function(delta){
    delta = delta || 1;

    this.x += this.vx;
    this.y += this.vy;

    this.animate += delta;

    if (this.type === 12) {
        this.shoot += delta;

        if (this.shoot > this.shootTimer) {
            this.shoot = 0;
            this.bullets.shift();
            this.bullets.push(new Item({
                context: this.ctx,
                type: 12,
                img: imgBullet,
                vx: -this.bulletSpeed * this.direction,
                x: 0, 
                y: -16
            }));
        }

        for (var i=0; i<this.bullets.length; i++) {
            this.bullets[i].update();
        }
    }
};
Monster.prototype.render = function(ctx){
    ctx = ctx || this.ctx || false;

    if (ctx) {
        ctx.save();
            ctx.translate(this.x, this.y);
            ctx.scale(this.direction, 1);
            if (this.img) {
                if (this.animate < 700) {
                    this.spriteY = 0;
                } else if (this.animate < 1000) {
                    this.spriteY = this.height/2;
                } else if (this.animate >= 1000) {
                    this.animate = 0;
                }
                if (this.type === 12) {
                    ctx.globalAlpha = 0.8;
                }
                ctx.drawImage(this.img, 0, this.spriteY, this.width/2, this.height/2, this.left, this.top, this.width, this.height);

                ctx.scale(this.direction, 1);
                for (var i=0; i<this.bullets.length; i++) {
                    this.bullets[i].render();
                }
            } else {
                ctx.fillStyle = "this.color";
                ctx.fillRect(this.left, this.top, this.width, this.height);
            }
        ctx.restore();
    } else {
        console.log('No context specified in the update for:');
        console.log(this);
    }
};